-- Reduce particles send to client if on Server
local SERVER = minetest.is_singleplayer() or false
SERVER = not SERVER
local dur = 10

local VIEW_DISTANCE = 15 -- from what distance (in nodes) leaves are send to player/client

-- constants
local rotat = {"I", "FX"}
local particle_def = {
    pos = {x = 0, y = 0, z =0},
    velocity = {x = 0, y = 0, z = 0},
    acceleration = {x = 0, y = 0, z = 0},
    expirationtime = 10,
    size = 15,
    collisiondetection = true,
    vertical = false,
    texture = "default_acacia_leaves.png",
}

-- leaves falling
local function add_fire(pos, duration, offset)
	if offset then
		pos.x = pos.x + offset.x
		pos.z = pos.z + offset.z
		pos.y = pos.y + offset.y
	end
	pos.y = pos.y + 0.19
	particle_def.pos = pos
	particle_def.expirationtime = duration
	particle_def.texture = "default_acacia_leaves.png"
	minetest.add_particle(particle_def)

	pos.y = pos.y + 0.01
	particle_def.pos = pos
	particle_def.texture = "default_acacia_leaves.png"
	minetest.add_particle(particle_def)
end

-- helper functions
local function player_near(pos)
	for  _,object in ipairs(minetest.get_objects_inside_radius(pos, VIEW_DISTANCE)) do
		if object:is_player() then
			return true
		end
	end

	return false
end

local function get_offset(wdir)
	local z = 0
	local x = 0
	if wdir == 4 then
		z = 0.25
	elseif wdir == 2 then
		x = 0.25
	elseif wdir == 5 then
		z = -0.25
	elseif wdir == 3 then
		x = -0.25
	end
	return {x = x, y = 0.08, z = z}
		
end

-- abms for leaves

minetest.register_abm({
	nodenames = {"default:acacia_leaves"},
	interval = dur - 1,
	chance = 1,
	action = function(pos)
		if player_near(pos) then
			add_fire(pos, dur - .9)
		end
	end
})