-- Checks if a given position is already occupied
local function is_pos_occupied(pos)
	local name = minetest.get_node(pos).name
	if name == "default:leaves" then
		return false
	else
		return true
	end
end


-- Returns a random neighbour pos
local function get_neighbour(pos, prefer_horizontal)

	-- Generate three random integers from -1 to 1 that represent possible
	-- neighbour's coordinates projections
	local delta_x = math.random (-1,1)
	local delta_y = math.random (-1,1)
	local delta_z = math.random (-1,1)
	
	local neighbour = {
		x = pos.x + delta_x,
		y = pos.y + delta_y,
		z = pos.z + delta_z}

	-- Return the result
	return neighbour
end

minetest.register_abm({
	nodenames = {"default:apple"},
	interval = 40,
	chance = 3,
	action = function(pos, node, active_object_count, active_object_count_wider)

		local neighbour = get_neighbour(pos, true)
		if not is_pos_occupied(neighbour) then
			minetest.set_node(neighbour, node)
		end
	end,
})
