minetest.override_item("default:jungleleaves", {groups = {snappy=3, leafdecay=1, flammable=2, leaves=1},
visual_scale = 1.1,
drawtype = "plantlike",
walkable = false,
climbable = true,
})
minetest.override_item("default:leaves", {groups = {snappy=3, leafdecay=1, flammable=2, leaves=1},
visual_scale = 1.1,
drawtype = "plantlike",
walkable = false,
climbable = true,
})
minetest.override_item("default:acacia_leaves", {groups = {snappy=3, leafdecay=1, flammable=2, leaves=1},
visual_scale = 1.1,
drawtype = "plantlike",
walkable = false,
climbable = true,
})
minetest.override_item("default:aspen_leaves", {groups = {snappy=3, leafdecay=1, flammable=2, leaves=1},
visual_scale = 1.1,
drawtype = "plantlike",
walkable = false,
climbable = true,
})
minetest.override_item("default:apple", {groups = {snappy=3, leafdecay=1, flammable=2},
visual_scale = 1.1,
drawtype = "plantlike",
tiles = {"default_leaves.png^default_apple.png"},
walkable = false,
climbable = true,
})


--for falling leaves!
local path = minetest.get_modpath("treegrow")
--dofile(path.."/leaves.lua")
--CURRENTLY DISABLED|ACTIVATE AT YOUR OWN RISKS


-- Checks if a given position is already occupied
local function is_pos_occupied(pos)
	local name = minetest.get_node(pos).name
	if name == "air" then
		return false
	else
		return true
	end
end

-- Returns a random neighbour pos
local function get_neighbour(pos, prefer_horizontal)

	-- Generate three random integers from -1 to 1 that represent possible
	-- neighbour's coordinates projections
	local delta_x = math.random (-0.5,0.5)
	local delta_y = math.random (0,0.5)
	local delta_z = math.random (-0.5,0.5)

	
	local neighbour = {
		x = pos.x + delta_x,
		y = pos.y + delta_y,
		z = pos.z + delta_z}

	-- Return the result
	return neighbour
end

minetest.register_abm({
	nodenames = {"default:jungleleaves","default:acacia_leaves","default:aspen_leaves","default:leaves"},
	interval = 30,
	chance = 2,
	action = function(pos, node, active_object_count, active_object_count_wider)

		local neighbour = get_neighbour(pos, true)
		if not is_pos_occupied(neighbour) then
			minetest.set_node(neighbour, node)
		end
	end,
})

minetest.register_abm({
	nodenames = {"default:tree","default:acacia_tree","default:aspen_tree","default:jungletree"},
	interval = 30,
	chance = 2,
	action = function(pos, node, active_object_count, active_object_count_wider)
	local neighbour = get_neighbour(pos, true)
	if is_pos_occupied(neighbour) then
	minetest.set_node(neighbour, node)
	end
end,
})